Index: src/apps/screenshot/ScreenshotWindow.cpp
===================================================================
--- src/apps/screenshot/ScreenshotWindow.cpp	(Revision 30358)
+++ src/apps/screenshot/ScreenshotWindow.cpp	(Arbeitskopie)
@@ -49,7 +49,7 @@
 enum {
 	kScreenshotType,
 	kIncludeBorder,
-	kShowCursor,
+	kShowMouse,
 	kBackToSave,
 	kTakeScreenshot,
 	kImageOutputFormat,
@@ -78,7 +78,7 @@
 
 
 ScreenshotWindow::ScreenshotWindow(bigtime_t delay, bool includeBorder,
-	bool includeCursor, bool grabActiveWindow, bool showConfigWindow,
+	bool includeMouse, bool grabActiveWindow, bool showConfigWindow,
 	bool saveScreenshotSilent)
 	: BWindow(BRect(0, 0, 200.0, 100.0), "Take Screenshot", B_TITLED_WINDOW,
 		B_NOT_ZOOMABLE | B_NOT_RESIZABLE | B_QUIT_ON_WINDOW_CLOSE |
@@ -89,7 +89,7 @@
 	fLastSelectedPath(NULL),
 	fDelay(delay),
 	fIncludeBorder(includeBorder),
-	fIncludeCursor(includeCursor),
+	fIncludeMouse(includeMouse),
 	fGrabActiveWindow(grabActiveWindow),
 	fShowConfigWindow(showConfigWindow)
 {
@@ -129,8 +129,8 @@
 				fIncludeBorder = (fWindowBorder->Value() == B_CONTROL_ON);
 		}	break;
 
-		case kShowCursor: {
-			fIncludeCursor = (fShowCursor->Value() == B_CONTROL_ON);
+		case kShowMouse: {
+			fIncludeMouse = (fShowMouse->Value() == B_CONTROL_ON);
 		}	break;
 
 		case kBackToSave: {
@@ -166,7 +166,7 @@
 				BMessenger target(this);
 				fOutputPathPanel = new BFilePanel(B_OPEN_PANEL, &target,
 					NULL, B_DIRECTORY_NODE, false, NULL, new DirectoryRefFilter());
-				fOutputPathPanel->Window()->SetTitle("Choose directory");
+				fOutputPathPanel->Window()->SetTitle("Choose folder");
 				fOutputPathPanel->SetButtonLabel(B_DEFAULT_BUTTON, "Select");
 			}
 			fOutputPathPanel->Show();
@@ -243,7 +243,7 @@
 
 	fActiveWindow = new BRadioButton("Take active window",
 		 new BMessage(kScreenshotType));
-	fWholeDesktop = new BRadioButton("Take whole Desktop",
+	fWholeDesktop = new BRadioButton("Take whole screen",
 		 new BMessage(kScreenshotType));
 	fWholeDesktop->SetValue(B_CONTROL_ON);
 
@@ -261,9 +261,9 @@
 		new BMessage(kIncludeBorder));
 	fWindowBorder->SetEnabled(false);
 
-	fShowCursor = new BCheckBox("Include cursor in screenshot",
-		new BMessage(kShowCursor));
-	fShowCursor->SetValue(fIncludeCursor);
+	fShowMouse = new BCheckBox("Include mouse pointer in screenshot",
+		new BMessage(kShowMouse));
+	fShowMouse->SetValue(fIncludeMouse);
 
 	BBox* divider = new BBox(B_FANCY_BORDER, NULL);
 	divider->SetExplicitMaxSize(BSize(B_SIZE_UNLIMITED, 1));
@@ -289,7 +289,7 @@
 		.AddStrut(10.0)
 		.AddGroup(B_HORIZONTAL)
 			.AddStrut(15.0)
-			.Add(fShowCursor)
+			.Add(fShowMouse)
 			.End()
 		.AddStrut(5.0)
 		.AddGroup(B_HORIZONTAL, 5.0)
@@ -428,7 +428,7 @@
 	BPath path;
 	find_directory(B_USER_DIRECTORY, &path);
 
-	BString label("Home directory");
+	BString label("Home folder");
 	_AddItemToPathMenu(path.Path(), label, 0, (path.Path() == lastSelectedPath));
 
 	path.Append("Desktop");
@@ -438,7 +438,7 @@
 	find_directory(B_BEOS_ETC_DIRECTORY, &path);
 	path.Append("artwork");
 
-	label.SetTo("Artwork directory");
+	label.SetTo("Artwork folder");
 	_AddItemToPathMenu(path.Path(), label, 2, (path.Path() == lastSelectedPath));
 
 	int32 i = 0;
@@ -459,7 +459,7 @@
 	}
 
 	fOutputPathMenu->AddItem(new BSeparatorItem());
-	fOutputPathMenu->AddItem(new BMenuItem("Choose directory...",
+	fOutputPathMenu->AddItem(new BMenuItem("Choose folder...",
 		new BMessage(kChooseLocation)));
 }
 
@@ -626,9 +626,9 @@
 	delete fScreenshot;
 	if (_GetActiveWindowFrame(&frame) == B_OK) {
 		fScreenshot = new BBitmap(frame.OffsetToCopy(B_ORIGIN), B_RGBA32);
-		BScreen(this).ReadBitmap(fScreenshot, fIncludeCursor, &frame);
+		BScreen(this).ReadBitmap(fScreenshot, fIncludeMouse, &frame);
 	} else {
-		BScreen(this).GetBitmap(&fScreenshot, fIncludeCursor);
+		BScreen(this).GetBitmap(&fScreenshot, fIncludeMouse);
 	}
 }
 
@@ -731,7 +731,7 @@
 
 	BPath homePath;
 	if (find_directory(B_USER_DIRECTORY, &homePath) != B_OK) {
-		fprintf(stderr, "failed to find user home directory\n");
+		fprintf(stderr, "failed to find user home folder\n");
 		return;
 	}
 
Index: src/apps/screenshot/ScreenshotWindow.h
===================================================================
--- src/apps/screenshot/ScreenshotWindow.h	(Revision 30358)
+++ src/apps/screenshot/ScreenshotWindow.h	(Arbeitskopie)
@@ -22,7 +22,7 @@
 public:
 							ScreenshotWindow(bigtime_t delay = 0,
 								bool includeBorder = false,
-								bool includeCursor = false,
+								bool includeMouse = false,
 								bool grabActiveWindow = false,
 								bool showConfigWindow = false,
 								bool saveScreenshotSilent = false);
@@ -62,7 +62,7 @@
 			BRadioButton*	fWholeDesktop;
 			BTextControl*	fDelayControl;
 			BCheckBox*		fWindowBorder;
-			BCheckBox*		fShowCursor;
+			BCheckBox*		fShowMouse;
 			BButton*		fBackToSave;
 			BButton*		fTakeScreenshot;
 			BTextControl*	fNameControl;
@@ -75,7 +75,7 @@
 			bigtime_t		fDelay;
 
 			bool			fIncludeBorder;
-			bool			fIncludeCursor;
+			bool			fIncludeMouse;
 			bool			fGrabActiveWindow;
 			bool			fShowConfigWindow;
 
Index: src/apps/screenshot/Screenshot.cpp
===================================================================
--- src/apps/screenshot/Screenshot.cpp	(Revision 30358)
+++ src/apps/screenshot/Screenshot.cpp	(Arbeitskopie)
@@ -45,8 +45,8 @@
 	bool includeBorder = false;
 	message->FindBool("border", &includeBorder);
 
-	bool includeCursor = false;
-	message->FindBool("border", &includeCursor);
+	bool includeMouse = false;
+	message->FindBool("border", &includeMouse);
 
 	bool grabActiveWindow = false;
 	message->FindBool("window", &grabActiveWindow);
@@ -57,7 +57,7 @@
 	bool showConfigureWindow = false;
 	message->FindBool("configure", &showConfigureWindow);
 
-	new ScreenshotWindow(delay * 1000000, includeBorder, includeCursor,
+	new ScreenshotWindow(delay * 1000000, includeBorder, includeMouse,
 		grabActiveWindow, showConfigureWindow, saveScreenshotSilent);
 
 	fRefsReceived = true;
@@ -70,7 +70,7 @@
 	bigtime_t delay = 0;
 
 	bool includeBorder = false;
-	bool includeCursor = false;
+	bool includeMouse = false;
 	bool grabActiveWindow = false;
 	bool showConfigureWindow = false;
 	bool saveScreenshotSilent = false;
@@ -80,8 +80,8 @@
 			_ShowHelp();
 		else if (strcmp(argv[i], "-b") == 0 || strcmp(argv[i], "--border") == 0)
 			includeBorder = true;
-		else if (strcmp(argv[i], "-c") == 0 || strcmp(argv[i], "--cursor") == 0)
-			includeCursor = true;
+		else if (strcmp(argv[i], "-m") == 0 || strcmp(argv[i], "--mouse") == 0)
+			includeMouse = true;
 		else if (strcmp(argv[i], "-w") == 0 || strcmp(argv[i], "--window") == 0)
 			grabActiveWindow = true;
 		else if (strcmp(argv[i], "-s") == 0 || strcmp(argv[i], "--silent") == 0)
@@ -99,7 +99,7 @@
 		}
 	}
 	fArgvReceived = true;
-	new ScreenshotWindow(delay, includeBorder, includeCursor, grabActiveWindow,
+	new ScreenshotWindow(delay, includeBorder, includeMouse, grabActiveWindow,
 		showConfigureWindow, saveScreenshotSilent);
 }
 
@@ -107,15 +107,15 @@
 void
 Screenshot::_ShowHelp() const
 {
-	printf("Screenshot [OPTION]... Creates a Bitmap of the current screen\n\n");
+	printf("Screenshot [OPTION]... Creates a bitmap of the current screen\n\n");
 	printf("OPTION\n");
 	printf("  -o, --options         Show options window first\n");
-	printf("  -c, --cursor          Have the cursor inside the screenshot\n");
+	printf("  -m, --mouse           Have the mouse pointer in the screenshot\n");
 	printf("  -b, --border          Include the window border with the screenshot\n");
 	printf("  -w, --window          Use active window instead of the entire screen\n");
 	printf("  -d, --delay=seconds   Take screenshot after specified delay [in seconds]\n");
-	printf("  -s, --silent          Saves the screenshot without the application window\n");
-	printf("                        overwrites --options, saves to home directory as png\n");
+	printf("  -s, --silent          Saves the screenshot without showing the app window\n");
+	printf("                        overrides --options, saves to home folder as png\n");
 	printf("\n");
 	printf("Note: OPTION -b, --border takes only effect when used with -w, --window\n");
 